local mod = RW:Boss("Ragnaros", "Molten Core")
local L

mod.BossIcon = [[Interface\Icons\achievement_boss_ragnaros]]

---------------------------
-- Variables

-- Submerge
local tSubmergeCD, mSubmerge

-- Emerge
local tEmerge, wEmerge

-- Knockback
local tKnockbackCD, mKnockback


---------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L.Submerge = "COME FORTH, MY SERVANTS! DEFEND YOUR MASTER!"
		L.Sons = "Sons killed"
		L.submerge_emerge = "Submerge/Emerge"
		L.submerge = "Submerge"
		L.emerge = "Emerge"
	end
	L = mod:GetLocale()
	self.L = L
	
	self:SetTrigger(11502)
	self:SetWin(11502)
	
	-- Submerge
	tSubmergeCD			= self:CustomTimer(180, L.submerge, L.submerge_emerge, [[Interface\Icons\Achievement_Dungeon_TheVioletHold_Heroic]])
	mSubmerge			= self:CustomMessage(L.submerge, L.submerge_emerge, [[Interface\Icons\Achievement_Dungeon_TheVioletHold_Heroic]])
	
	-- Emerge
	tEmerge				= self:CustomTimer(90, L.emerge, L.submerge_emerge, [[Interface\Icons\Achievement_Dungeon_Ulduar80_Heroic]])
	wEmerge				= self:CustomWarning(L.emerge, L.submerge_emerge, [[Interface\Icons\Achievement_Dungeon_Ulduar80_Heroic]])
	
	-- Knockback
	tKnockbackCD		= self:CDTimer(25, 20566)
	mKnockback			= self:CastMessage(20566)
end

---------------------------
-- Locals

local sonsKilled

local function SonsUpdate()
	return sonsKilled, 8, L.Sons
end

-- API Functions

function mod:OnEngage(trigger)
	self:Track("Knockback", 20566)
	self:YellTrack("Submerge", L.Submerge)	
	
	sonsKilled = 0
	
	tSubmergeCD:Start()
end

function mod:Knockback(event, args)
	if event == "SPELL_CAST_SUCCESS" then
		tKnockbackCD:Start()
		mKnockback:Show()
	end
end

function mod:Submerge(event, msg, name)
	self:Schedule("RaggyEmerging", 90, "Emerge")
	tSubmergeCD:Stop()
	
	mSubmerge:Show()	
	tEmerge:Start()
	
	sonsKilled = 0
	RW.Callbacks:Fire("MPBExternal", "RaggySons", SonsUpdate, nil, nil, [[Interface\Icons\Spell_Fire_Elemental_Totem]])
end

function mod:Emerge()	
	self:Unschedule("RaggyEmerging")
	tEmerge:Stop()
	
	tSubmergeCD:Start()
	wEmerge:Show()
	
	RW.Callbacks:Fire("MPBExternalHide", "RaggySons")
end

function mod:UNIT_DIED(cID, gUID)
	if cID == 12143 then
		sonsKilled = sonsKilled + 1
		if sonsKilled >= 8 then
			Emerge()
		end
	end
end
